Loading...
Searching...
No Matches
L4 IPC Opcodes

List of protocol specific opcodes used for communication with L4Re and Kernel objects. More...

## Enumerations

enum | L4_icu_opcode { L4_ICU_OP_BIND , L4_ICU_OP_UNBIND , L4_ICU_OP_INFO , L4_ICU_OP_MSI_INFO , L4_ICU_OP_UNMASK , L4_ICU_OP_MASK , L4_ICU_OP_SET_MODE }
| Opcodes to the ICU interface. More...
enum | L4_ipc_gate_ops { L4_IPC_GATE_BIND_OP = 0x10 , L4_IPC_GATE_GET_INFO_OP = 0x11 }
| Operations on the IPC-gate. More...
enum | L4_platform_ctl_ops { L4_PLATFORM_CTL_SYS_SUSPEND_OP = 0UL , L4_PLATFORM_CTL_SYS_SHUTDOWN_OP = 1UL , L4_PLATFORM_CTL_CPU_ALLOW_SHUTDOWN_OP = 2UL , L4_PLATFORM_CTL_CPU_ENABLE_OP = 3UL , L4_PLATFORM_CTL_CPU_DISABLE_OP = 4UL , L4_PLATFORM_CTL_SET_TASK_ASID_OP = 0x10UL }
| Operations on platform-control objects. More...
enum | L4_task_ops { L4_TASK_MAP_OP = 0UL , L4_TASK_UNMAP_OP = 1UL , L4_TASK_CAP_INFO_OP = 2UL , L4_TASK_ADD_KU_MEM_OP = 3UL , L4_TASK_LDT_SET_X86_OP = 0x11UL , L4_TASK_MAP_VGICC_ARM_OP = 0x12UL }
| Operations on task objects. More...

enum

L4_thread_ops {
L4_THREAD_CONTROL_OP = 0UL , L4_THREAD_EX_REGS_OP = 1UL , L4_THREAD_SWITCH_OP = 2UL , L4_THREAD_STATS_OP = 3UL ,
L4_THREAD_VCPU_RESUME_OP = 4UL , L4_THREAD_REGISTER_DELETE_IRQ_OP = 5UL , L4_THREAD_MODIFY_SENDER_OP = 6UL , L4_THREAD_VCPU_CONTROL_OP = 7UL ,
L4_THREAD_VCPU_CONTROL_EXT_OP = L4_THREAD_VCPU_CONTROL_OP | 0x10000 , L4_THREAD_REGISTER_DOORBELL_IRQ_OP = 8UL , L4_THREAD_X86_GDT_OP = 0x10UL , L4_THREAD_ARM_TPIDRURO_OP = 0x10UL ,
L4_THREAD_AMD64_SET_SEGMENT_BASE_OP = 0x12UL , L4_THREAD_AMD64_GET_SEGMENT_INFO_OP = 0x13UL , L4_THREAD_OPCODE_MASK = 0xffff
}

| Operations on thread objects. More...
enum | L4_vcon_ops { L4_VCON_WRITE_OP = 0UL , L4_VCON_READ_OP = 1UL , L4_VCON_SET_ATTR_OP = 2UL , L4_VCON_GET_ATTR_OP = 3UL }
| Operations on vcon objects. More...

## Detailed Description

List of protocol specific opcodes used for communication with L4Re and Kernel objects.

## Enumeration Type Documentation

## L4_icu_opcode

enum L4_icu_opcode

Opcodes to the ICU interface.

Enumerator

L4_ICU_OP_BIND

Bind opcode.

See also
  l4_icu_bind()

L4_ICU_OP_UNBIND

Unbind opcode.

See also
  l4_icu_unbind()

L4_ICU_OP_INFO

Info opcode.

See also
  l4_icu_info()

L4_ICU_OP_MSI_INFO

Msi-info opcode.

See also
  l4_icu_msi_info()

L4_ICU_OP_UNMASK

Unmask opcode.

See also
  l4_icu_unmask()

L4_ICU_OP_MASK

Mask opcode.

See also
  l4_icu_mask()

L4_ICU_OP_SET_MODE

Set-mode opcode.

See also
  l4_icu_set_mode()

Definition at line 97 of file icu.h.

## L4_ipc_gate_ops

enum L4_ipc_gate_ops

Operations on the IPC-gate.

Enumerator
L4_IPC_GATE_BIND_OP | Bind operation.
L4_IPC_GATE_GET_INFO_OP | Info operation.

Definition at line 108 of file ipc_gate.h.

## L4_platform_ctl_ops

enum L4_platform_ctl_ops

Operations on platform-control objects.

See L4_PROTO_PLATFORM_CTL for the protocol type to use for messages to platform-control objects.

Enumerator
L4_PLATFORM_CTL_SYS_SUSPEND_OP | Suspend.
L4_PLATFORM_CTL_SYS_SHUTDOWN_OP | shutdown/reboot
L4_PLATFORM_CTL_CPU_ALLOW_SHUTDOWN_OP | allow CPU shutdown
L4_PLATFORM_CTL_CPU_ENABLE_OP | enable an offline CPU
L4_PLATFORM_CTL_CPU_DISABLE_OP | disable an online CPU
L4_PLATFORM_CTL_SET_TASK_ASID_OP | Arm: set task ASID.

Definition at line 159 of file platform_control.h.

## L4_task_ops

enum L4_task_ops

Operations on task objects.

Enumerator
L4_TASK_MAP_OP | Map.
L4_TASK_UNMAP_OP | Unmap.
L4_TASK_CAP_INFO_OP | Cap info.
L4_TASK_ADD_KU_MEM_OP | Add kernel-user memory.
L4_TASK_LDT_SET_X86_OP | x86: LDT set
L4_TASK_MAP_VGICC_ARM_OP | Arm: Map virtual GICC area.

Definition at line 341 of file task.h.

## L4_thread_ops

enum L4_thread_ops

Operations on thread objects.

Enumerator
L4_THREAD_CONTROL_OP | Control operation.
L4_THREAD_EX_REGS_OP | Exchange registers operation.
L4_THREAD_SWITCH_OP | Do a thread switch.
L4_THREAD_STATS_OP | Thread statistics.
L4_THREAD_VCPU_RESUME_OP | VCPU resume.
L4_THREAD_REGISTER_DELETE_IRQ_OP | Register an IPC-gate deletion IRQ.
L4_THREAD_MODIFY_SENDER_OP | Modify all senders IDs that match the given pattern.
L4_THREAD_VCPU_CONTROL_OP | Enable / disable VCPU feature.
L4_THREAD_REGISTER_DOORBELL_IRQ_OP | Register direct IRQ injection doorbell IRQ.
L4_THREAD_X86_GDT_OP | Gdt.
L4_THREAD_ARM_TPIDRURO_OP | Set TPIDRURO register.
L4_THREAD_AMD64_SET_SEGMENT_BASE_OP | Set segment base.
L4_THREAD_AMD64_GET_SEGMENT_INFO_OP | Get segment information.
L4_THREAD_OPCODE_MASK | Mask for opcodes.

Definition at line 732 of file thread.h.

## L4_vcon_ops

enum L4_vcon_ops

Operations on vcon objects.

Enumerator
L4_VCON_WRITE_OP | Write.
L4_VCON_READ_OP | Read.
L4_VCON_SET_ATTR_OP | Get console attributes.
L4_VCON_GET_ATTR_OP | Set console attributes.

Definition at line 291 of file vcon.h.